VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmMain 
   Caption         =   "MediaTagConverter"
   ClientHeight    =   7935
   ClientLeft      =   60
   ClientTop       =   285
   ClientWidth     =   8895
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   7935
   ScaleWidth      =   8895
   StartUpPosition =   3  'Windows Default
   Begin MSFlexGridLib.MSFlexGrid gridFiles 
      Height          =   3135
      Left            =   120
      TabIndex        =   5
      Top             =   4320
      Width           =   8655
      _ExtentX        =   15266
      _ExtentY        =   5530
      _Version        =   393216
      Cols            =   7
      FixedCols       =   0
      SelectionMode   =   1
      AllowUserResizing=   1
   End
   Begin VB.DirListBox dirBox 
      Height          =   3240
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   8655
   End
   Begin VB.DriveListBox drvBox 
      Height          =   315
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   8655
   End
   Begin VB.CommandButton cmdOGGtoMP3 
      Caption         =   "Convert OGG tags to MP3 tags"
      Height          =   375
      Left            =   5760
      TabIndex        =   1
      Top             =   3840
      Width           =   3015
   End
   Begin VB.CommandButton cmdMP3toOGG 
      Caption         =   "Convert MP3 tags to OGG tags"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   3840
      Width           =   3015
   End
   Begin VB.Label lblStatus 
      Caption         =   "Ready."
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   7560
      Width           =   8655
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    gridFiles.FormatString = "<|<|<|<|<|<|<"
    gridFiles.ColWidth(0) = 3000
    gridFiles.ColWidth(1) = 2250
    gridFiles.ColWidth(2) = 2250
    gridFiles.ColWidth(3) = 1500
    gridFiles.ColWidth(4) = 750
    gridFiles.ColWidth(5) = 750
    gridFiles.ColWidth(6) = 750
    gridFiles.TextMatrix(0, 0) = "Filename"
    gridFiles.TextMatrix(0, 1) = "Title"
    gridFiles.TextMatrix(0, 2) = "Artist"
    gridFiles.TextMatrix(0, 3) = "Album"
    gridFiles.TextMatrix(0, 4) = "Track"
    gridFiles.TextMatrix(0, 5) = "Genre"
    gridFiles.TextMatrix(0, 6) = "Year"
    LoadFiles
End Sub

Private Sub cmdMP3toOGG_Click()
    ConvertTags True
End Sub

Private Sub cmdOGGtoMP3_Click()
    ConvertTags False
End Sub

Public Sub ConvertTags(blnMP3toOGG As Boolean)
    Dim fso As New FileSystemObject
    Dim fld As Folder
    Dim fil As File
    Dim strExtension As String, strTargetExtension As String
    Dim mp3 As clsMP3
    Dim ogg As clsOGG
    
    If blnMP3toOGG Then
        strExtension = ".mp3"
        strTargetExtension = ".ogg"
    Else
        strExtension = ".ogg"
        strTargetExtension = ".mp3"
    End If
    Set fld = fso.GetFolder(dirBox.List(dirBox.ListIndex))
    For Each fil In fld.Files
        lblStatus.Caption = fil.Name & " - Checking"
        DoEvents
        If Len(fil.Name) > 3 Then
            If LCase(Mid(fil.Name, Len(fil.Name) - 3, 4)) = strExtension Then
                If fso.FileExists(Mid(fil.Path, 1, Len(fil.Path) - 4) & strTargetExtension) Then
                    Set mp3 = New clsMP3
                    Set ogg = New clsOGG
                    If blnMP3toOGG Then
                        lblStatus.Caption = fil.Name & " - Loading MP3"
                        DoEvents
                        If mp3.LoadMP3(fil.Path) Then
                            lblStatus.Caption = fil.Name & " - Loading OGG"
                            DoEvents
                            If ogg.LoadOGG(Mid(fil.Path, 1, Len(fil.Path) - 4) & strTargetExtension) Then
                                lblStatus.Caption = fil.Name & " - Converting Tag"
                                DoEvents
                                If Len(mp3.strTitle) > 0 Then ogg.AddComment "Title", mp3.strTitle
                                If Len(mp3.strArtist) > 0 Then ogg.AddComment "Artist", mp3.strArtist
                                If Len(mp3.strAlbum) > 0 Then ogg.AddComment "Album", mp3.strAlbum
                                If mp3.lngGenreID > -1 Then ogg.AddComment "Genre", mp3.GetGenre(mp3.lngGenreID)
                                If Len(mp3.strComment) > 0 Then ogg.AddComment "Comment", mp3.strComment
                                If Len(mp3.strTrack) > 0 Then ogg.AddComment "Track", mp3.strTrack
                                If Len(mp3.strSongYear) > 0 Then ogg.AddComment "Year", mp3.strSongYear
                                lblStatus.Caption = fil.Name & " - Saving OGG"
                                DoEvents
                                ogg.WriteOgg
                            End If
                        End If
                    Else
                        lblStatus.Caption = fil.Name & " - Loading OGG"
                        DoEvents
                        If ogg.LoadOGG(fil.Path) Then
                            lblStatus.Caption = fil.Name & " - Loading MP3"
                            DoEvents
                            If mp3.LoadMP3(Mid(fil.Path, 1, Len(fil.Path) - 4) & strTargetExtension) Then
                                lblStatus.Caption = fil.Name & " - Converting Tag"
                                DoEvents
                                If Len(ogg.GetComment("Title")) > 0 Then mp3.strTitle = ogg.GetComment("Title")
                                If Len(ogg.GetComment("Artist")) > 0 Then mp3.strArtist = ogg.GetComment("Artist")
                                If Len(ogg.GetComment("Album")) > 0 Then mp3.strAlbum = ogg.GetComment("Album")
                                If Len(ogg.GetComment("Genre")) > 0 Then mp3.lngGenreID = mp3.GetGenreID(ogg.GetComment("Genre"))
                                If Len(ogg.GetComment("Comment")) > 0 Then mp3.strComment = ogg.GetComment("Comment")
                                If Len(ogg.GetComment("Track")) > 0 Then mp3.strTrack = ogg.GetComment("Track")
                                If Len(ogg.GetComment("Year")) > 0 Then mp3.strSongYear = ogg.GetComment("Year")
                                lblStatus.Caption = fil.Name & " - Saving MP3"
                                DoEvents
                                mp3.WriteID3v2
                            End If
                        End If
                    End If
                    Set mp3 = Nothing
                    Set ogg = Nothing
                End If
            End If
        End If
    Next
    lblStatus.Caption = "Updating grid"
    DoEvents
    LoadFiles
    lblStatus.Caption = "Ready."
End Sub

Private Sub dirBox_Change()
    LoadFiles
End Sub

Private Sub LoadFiles()
    Dim fso As New FileSystemObject
    Dim fld As Folder
    Dim fil As File
    Dim strExtension As String
    Dim mp3 As clsMP3
    Dim ogg As clsOGG
    Dim intNumFiles As Integer
    
    gridFiles.Rows = 2
    gridFiles.TextMatrix(1, 0) = ""
    gridFiles.TextMatrix(1, 1) = ""
    gridFiles.TextMatrix(1, 2) = ""
    gridFiles.TextMatrix(1, 3) = ""
    gridFiles.TextMatrix(1, 4) = ""
    gridFiles.TextMatrix(1, 5) = ""
    gridFiles.TextMatrix(1, 6) = ""
    intNumFiles = 0
    Set fld = fso.GetFolder(dirBox.List(dirBox.ListIndex))
    
    For Each fil In fld.Files
        If Len(fil.Name) > 3 Then
            strExtension = LCase(Mid(fil.Name, Len(fil.Name) - 3, 4))
            Select Case strExtension
                Case ".mp3"
                    Set mp3 = New clsMP3
                    If mp3.LoadMP3(fil.Path) Then
                        intNumFiles = intNumFiles + 1
                        gridFiles.Rows = intNumFiles + 1
                        gridFiles.TextMatrix(intNumFiles, 0) = fil.Name
                        gridFiles.TextMatrix(intNumFiles, 1) = mp3.strTitle
                        gridFiles.TextMatrix(intNumFiles, 2) = mp3.strArtist
                        gridFiles.TextMatrix(intNumFiles, 3) = mp3.strAlbum
                        gridFiles.TextMatrix(intNumFiles, 4) = mp3.strTrack
                        gridFiles.TextMatrix(intNumFiles, 5) = mp3.GetGenre(mp3.lngGenreID)
                        gridFiles.TextMatrix(intNumFiles, 6) = mp3.strSongYear
                    End If
                    Set mp3 = Nothing
                Case ".ogg"
                    Set ogg = New clsOGG
                    If ogg.LoadOGG(fil.Path) Then
                        intNumFiles = intNumFiles + 1
                        gridFiles.Rows = intNumFiles + 1
                        gridFiles.TextMatrix(intNumFiles, 0) = fil.Name
                        gridFiles.TextMatrix(intNumFiles, 1) = ogg.GetComment("Title")
                        gridFiles.TextMatrix(intNumFiles, 2) = ogg.GetComment("Artist")
                        gridFiles.TextMatrix(intNumFiles, 3) = ogg.GetComment("Album")
                        gridFiles.TextMatrix(intNumFiles, 4) = ogg.GetComment("Track")
                        gridFiles.TextMatrix(intNumFiles, 5) = ogg.GetComment("Genre")
                        gridFiles.TextMatrix(intNumFiles, 6) = ogg.GetComment("Year")
                    End If
                    Set ogg = Nothing
            End Select
        End If
    Next
End Sub

Private Sub Form_Resize()
    If Me.WindowState <> 0 Then Exit Sub
    If Me.Width < 6600 Then Me.Width = 6600
    Me.Height = 8340
    drvBox.Width = Me.Width - 360
    dirBox.Width = Me.Width - 360
    gridFiles.Width = Me.Width - 360
    lblStatus.Width = Me.Width - 360
    cmdOGGtoMP3.Left = Me.Width - 3255
End Sub
